/**
 * @class Sb.dashboard.model.Ecwid
 * @extends Sb.dashboard.Model
 * Ecwid orders model
 */
Ext.define('Sb.dashboard.model.Ecwid', {
	extend: 'Sb.dashboard.Model',

	name: 'ecwid',

	isEnabled: function () {
		return Sb.Config.widgets.indexOf('eshop_catalog') !== -1;
	},

	loadData: function () {
		if (!Sb.Editor.model.get('ecwidStoreId')
			|| (Sb.Editor.model.get('ecwidStoreId') && !Sb.EcwidWidgetsManager.isProductBrowserWidget())) {
			this.lastError = Sb.Locale.get('eshopNotInstalled');
			this.fireEvent('error', this, this.lastError, 'warning');
			return;
		}

		Sb.EcwidService.orders(function (result) {
			if (result.success) {
				this.data = result.data;
				if (this.data.orders) {
					this.data.orders = this.data.orders.reverse();
				}
				this.fireEvent('datachanged', this);
			} else {
				var localeKey = result.localeKey || 'eshopLoadError';
				this.lastError = result.message || Sb.Locale.get(localeKey, Sb.Config.general.product);
				this.fireEvent('error', this, this.lastError, result.errorType);
			}
		}, this);
	}

});