/**
 * @class Sb.editor.DesignPresetsPanel
 * @extends Ext.Panel
 * Design presets editor panel
 * @constructor
 * @param {Object} config The config object
 * @xtype designpresetspanel
 */
Ext.define('Sb.editor.DesignPresetsPanel', {
	extend: 'Ext.Panel',
	xtype: 'designpresetspanel',

	initComponent: function () {
		var cmpId = this.getId();

		Ext.apply(this, {
			title: Sb.Locale.get('designPresetsTab'),
			cls: 'sb-editor-design-presets-panel',
			helperMessage: Sb.Locale.get('designPresetsTabDescription'),
			items: [{
				ref: 'view',
				xtype: 'dataview',
				cls: 'sb-editor-design-presets-view',
				height: '400',
				store: 'DesignPresets',
				tpl: new Ext.XTemplate(
					'<tpl for=".">' +
						'<tpl if="presets.length &gt; 0">' +
							'<div class="category" id="category-{#}">' +
								'<h3 class="category-title">' +
									'<span onClick="Ext.get(this).up(\'.category\').toggleClass(\'collapsed\');">' +
										'<em></em>{[Sb.Locale.get(\'designPresets\' + values.type.toUpperCaseFirst())]}' +
									'</span>' +
								'</h3>' +
								'<div class="category-description">' +
									'{[Sb.Locale.get(\'designPresets\' + values.type.toUpperCaseFirst() + \'Description\')]}' +
								'</div>' +
								'<ul class="presets-box clearfix">' +
								'<tpl for="presets">' +
									'<li class="presets-box-item">' +
										'<img src="{[Sb.Config.templatesUrl]}{screenshot}" />' +
									'</li>' +
								'</tpl>' +
								'</ul>' +
							'</div>' +
						'</tpl>' +
					'</tpl>'
				),
				itemSelector: '.presets-box-item',
				overClass: 'x-view-over',
				autoScroll: true,
				loadingText: Sb.Locale.get('dataLoading')
			}]
		});
		Sb.editor.StyleBorderPanel.superclass.initComponent.apply(this, arguments);
	}
});