/**
 * Class for Amazon Store widget model
 *
 * @class Sb.model.AmazonStoreWidget
 * @extends Sb.model.Widget
 */
Ext.define('Sb.model.AmazonStoreWidget', {
	extend: 'Sb.model.Widget',

	constructor: function (config) {
		config = Ext.apply({
			type: 'amazon_store'
		}, config);

		Sb.model.AmazonStoreWidget.superclass.constructor.call(this, config);
	},

	onUnserializePropertyChange: function (key) {
		if (key === 'url') {
			this.updateIsConfiguredProperties();
		}
	},

	computeIsConfiguredProperties: function () {
		return !!this.get('url');
	}
});