/**
 * Class for breadcrumbs widget model
 *
 * @class Sb.model.BreadcrumbsWidget
 * @extends Sb.model.Widget
 */
Ext.define('Sb.model.BreadcrumbsWidget', {
	extend: 'Sb.model.Widget',
	translatableFields: ['startPageTitle'],

	/**
	 * @cfg {String} type
	 * defaults to <tt>breadcrumbs</tt>
	 */

	constructor: function (config) {
		config = Ext.apply({
			type: 'breadcrumbs'
		}, config);

		Sb.model.BreadcrumbsWidget.superclass.constructor.call(this, config);

		var design = Sb.Editor.model.design;
		//								Generator & property			Dependable & property
		Sb.ModelDependencyManager.attach(design, 'font.textFont',		this, 'fontFamily');
		Sb.ModelDependencyManager.attach(design, 'font.textFontSize',	this, 'fontSize');
	},

	/**
	 * Modify font-size property as it always -2 px from dependent.
	 *
	 * @param {String} key
	 * @param {String} value
	 * @returns {Boolean} Result of setting
	 */
	updateDependentProperty: function (key, value) {
		if ('fontSize' == key) {
			value = value - 2;
		}

		return Sb.model.BreadcrumbsWidget.superclass.updateDependentProperty.call(this, key, value);
	}
});
