/**
 * Class for ColumnsColumn widget model
 *
 * @class Sb.model.ColumnsColumnWidget
 * @extends Sb.model.Widget
 */
Ext.define('Sb.model.ColumnsColumnWidget', {
	extend: 'Sb.model.Widget',

	constructor: function (config) {
		config = Ext.apply({
			type: 'columns_column'
		}, config);

		Sb.model.ColumnsColumnWidget.superclass.constructor.call(this, config);
	},

	/**
	 * This method invert a logic container.insert(). Handle a event execute widget from container.
	 * In the logic of the widget is responsible the container from which the widget is moved
	 * @param {Sb.model.Widget} container
	 * @param {Sb.model.Widget} widget
	 * @param {Number} position
	 * @returns {Boolean} if return false logics of insert method willbe skiped;
	 */
	onExclude: function (container, widget, position) {
		// :TODO: smikhalyev@20120304: Need rework this method.

		var columnsModel = this.ownerWidget, otherColumn, insertion;
		if (this.widgets.getCount() != 1) {
			return true;
		}

		if (columnsModel.widgets.indexOf(container) != -1) {
			if (columnsModel.widgets.getCount() == 2) {
				otherColumn = columnsModel.widgets.find(function (columnModel) {
					return columnModel != this;
				}, this);

				columnsModel.widgets.each(function (column) {
					column.isOnExclude = false;
				});

				insertion = columnsModel.moveAllFromColumn(otherColumn);
				insertion.container.insert(insertion.position + position, widget);
				columnsModel.ownerWidget.removeChild(columnsModel);
			} else {
				this.isOnExclude = false;
				container.insert(position, widget);
				columnsModel.removeChild(this);
			}
		} else {
			if (columnsModel.widgets.getCount() == 2) {
				otherColumn = columnsModel.widgets.find(function (columnModel) {
					return columnModel != this;
				}, this);
				columnsModel.widgets.each(function (column) {
					column.isOnExclude = false;
				});

				if (container == columnsModel.ownerWidget && position == container.widgets.indexOf(columnsModel)) {
					container.insert(position + 1, widget);
					columnsModel.moveAllFromColumn(otherColumn, container, position + 2);
				} else {
					container.insert(position, widget);
					columnsModel.moveAllFromColumn(otherColumn);
				}
				columnsModel.ownerWidget.removeChild(columnsModel);
			} else {
				this.isOnExclude = false;
				container.insert(position, widget);
				columnsModel.removeChild(this);
			}
		}
		return false;
	},

	removeChild: function (widgetModel, isSuppressEvents, callback, scope) {
		Sb.model.ColumnsColumnWidget.superclass.removeChild.call(this, widgetModel, isSuppressEvents, callback, scope);

		if (this.widgets.getCount() == 1) {
			var columnsModel = this.ownerWidget;
			if (columnsModel.widgets.getCount() == 2) {
				var otherColumn = columnsModel.widgets.find(function (columnModel) {
					return columnModel != this;
				}, this);
				otherColumn.isOnExclude = false;
				columnsModel.moveAllFromColumn(otherColumn);
				columnsModel.ownerWidget.removeChild(columnsModel);
			} else {
				columnsModel.removeChild(this);
			}
		}
	}
});