/**
 * @class Sb.model.ScriptWidget
 * @extends Sb.model.Widget
 * Class for script model
 * @constructor
 * @param {Object} config The configuration options for the widget model
 */
Ext.define('Sb.model.ScriptWidget', {
	extend: 'Sb.model.Widget',

	constructor: function (config) {
		config = Ext.apply({
			type: 'script'
		}, config);

		Sb.model.ScriptWidget.superclass.constructor.call(this, config);
	},

	/**
	 * Gets current widget`s code
	 *
	 * @returns {String}
	 */
	getCode: function () {
		return this.get('code');
	},

	onUnserializePropertyChange: function (key) {
		if (key === 'code') {
			this.updateIsConfiguredProperties();
		}
	},

	computeIsConfiguredProperties: function () {
		return !!this.getCode();
	}
});
