/**
 * @class Sb.utils.Flash
 * <p>Contains a utils functions for flash.</p>
 * @singleton
 */
Ext.define('Sb.utils.Flash', {
	singleton: true,

	isFlash: function (name) {
		var re = /\.swf[\?0-9]*$/i;
		return re.test(name);
	},

	createCode: function (url, width, height, options) {
		options = options || {};
		var id = options.id || Ext.id(),
			mask = (undefined !== options.withMask && false === options.withMask
				? ''
				: '<div class="ext-el-mask"></div>'),
			style = options.style ? 'style="' + options.style + '" ' : '';

		return '<object id="' + id + '" width="' + width + '" height="' +
					height + '" classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" ' +
					style +
					'codebase="https://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,115,0">' +
				'<param name="movie" value="' + url + '" />' +
				'<param name="allowFullScreen" value="true" />' +
				'<param name="wmode" value="transparent" />' +
				'<param name="allowscriptaccess" value="always" />' +
				'<embed src="' + url + '" type="application/x-shockwave-flash" ' +
					'width="' + width + '" height="' + height +
					'" wmode="transparent" allowscriptaccess="always" allowfullscreen="true"></embed>' +
			'</object>' +
			mask;
	},

	getSize: function (url) {
		var re = /_(\d*)x(\d*)\.swf[\?0-9]*$/i,
			result = re.exec(url);

		if (result) {
			return {
				width: result[1],
				height: result[2]
			};
		}

		return {
			width: '',
			height: ''
		};
	},

	setObjectSize: function (el, size) {
		var embed;

		el = el.is('object') ? el : el.child('object');
		if (el) {
			el.set(size);
			embed = el.child('embed');
			if (embed) {
				embed.set(size);
			}
		}
	}
});