/**
 * @class Sb.widget.Hidden
 * @extends Sb.widget.Widget
 * Class for hidden widget
 * @xtype hidden_widget
 */
Ext.define('Sb.widget.Hidden', {
	extend: 'Sb.widget.Widget',
	xtype: 'hidden_widget',

	cls: 'sb-widget-hidden',

	initComponent: function () {
		// hidden widget will never be edited
		this.hasEditButton = false;
		this.clickable = false;

		Sb.widget.Hidden.superclass.initComponent.apply(this, arguments);
	},

	onRender: function () {
		Sb.widget.Hidden.superclass.onRender.apply(this, arguments);
		this.togglePlaceholder(true);
		this.addClass(this.getStateCls('inactive'));
		this.update(this.placeholderTpl.apply({
			placeholderMsg: Sb.Locale.get('hiddenWidgetText')
		}));
	}
});