/**
 * @class Sb.widget.Pagecontent
 * @extends Sb.widget.Widget
 * @constructor
 * @param {Object} config The config object
 * @xtype pagecontent_widget
 */
Ext.define('Sb.widget.Pagecontent', {
	extend: 'Sb.widget.Widget',
	xtype: 'pagecontent_widget',
	cls: 'sb-widget-pagecontent',

	movable: false,
	removable: false,

	hasVisibilityControl: false,

	onRender: function () {
		Sb.widget.Pagecontent.superclass.onRender.apply(this, arguments);

		this.contentContainerWidget = new Sb.widget.PagecontentContainer({
			renderTo	: this.widgetContentEl,
			model		: Sb.Editor.siteView.currentPage.widget.widgets.get(this.model.get('placeholder'))
		});

		this.pageContentLabelEl = this.controlsTargetEl.createChild({
			tag: 'span',
			cls: 'sb-pagecontent-control-item',
			html: Sb.Locale.get('propertiesPagecontentLabel')
		});

		this.mon(this.contentElement, 'contextmenu', Sb.Editor.Ui.onContextMenu, Sb.Editor.Ui, {
			type	: 'widget',
			widget	: this
		});
	},

	onDestroy: function () {
		this.contentContainerWidget.destroy();
		Sb.widget.Pagecontent.superclass.onDestroy.call(this);
	}
});