/**
 * Allows to edit Share This widget.
 *
 * @class Sb.widget.SharethisEditPanel
 * @extends Sb.widget.WidgetEditPanel
 */
Ext.define('Sb.widget.SharethisEditPanel', {
	extend: 'Sb.widget.WidgetEditTabPanel',

	cls: 'sb-widget-edit-panel-sharethis',

	initComponent: function () {
		var appearanceRadioGroupItems = [];
		Ext.iterate(Sb.widget.Sharethis.appearancePresets, function (name, data) {
			appearanceRadioGroupItems.push({
				inputValue: name,
				boxLabel: '<img class="thumb" src="' + Sb.Config.baseUrl + '/widgets/sharethis/images/' + name + '.png" />'
			});
		});

		Ext.apply(this, {
			items: [{
				ref: '../appearanceTab',
				cls: 'sb-widget-sharethis-appearance-panel',
				title: Sb.Locale.get('widgetSharethisAppearanceTabTitle'),
				autoHeight: true,
				items: [{
					ref: '../../appearanceRadioGroup',
					xtype: 'radiogroup',
					columns: 2,
					defaults: {
						name: 'appearance'
					},
					items: appearanceRadioGroupItems,
					listeners: {
						scope: this,
						change: function (radiogroup) {
							var appearance = radiogroup.getValue().inputValue;
							this.widget.model.set('appearance', appearance);
						}
					}
				}],
				listeners: {
					scope: this,
					activate: this.initAppearanceTab
				}
			}]
		});

		Sb.widget.SharethisEditPanel.superclass.initComponent.apply(this, arguments);
	},

	show: function () {
		this.loadedTabs = {};
		Sb.widget.SharethisEditPanel.superclass.show.apply(this, arguments);
	},

	initAppearanceTab: function () {
		this.reanchor();

		if (this.loadedTabs.appearance) {
			return;
		}
		this.loadedTabs.appearance = true;

		var appearance = this.widget.model.get('appearance');
		this.appearanceRadioGroup.setValue(appearance);
	}
});
