/**
 * Class for Amazon Store widget type
 *
 * @class Sb.widgetType.AmazonStore
 * @extends Sb.widgetType.Base
 */
Ext.define('Sb.widgetType.AmazonStore', {
	extend: 'Sb.widgetType.Base',

	allowedColors: '',

	/**
	 * Gets type for creating child
	 * @return {String}
	 */
	getPhpType: function () {
		return 'amazon_store';
	},

	isDroppableTo: function (container) {
		return !container.isInSiteWideArea() &&
			container.get('type') === 'container_vertical' &&
			container.get('region') === 'content';
	},

	isAvailable: function () {
		this.disableReason = '';

		if (!Sb.Editor.siteView.currentPage) {
			return true;
		}

		var masterWidget = Sb.Editor.siteView.currentPage.getMasterWidget();
		if (masterWidget) {
			this.disableReason = masterWidget.getType().name;
			return false;
		}

		return true;
	}
});