/**
 * @class Sb.widgetType.EshopBasket
 * @extends Sb.widgetType.Base
 */
Ext.define('Sb.widgetType.EshopBasket', {
	extend: 'Sb.widgetType.Base',

	allowedColors: '',

	isDroppableTo: function (container) {
		return container.isInSiteWideArea();
	},

	/**
	 * Gets type for creating child
	 * @return {String}
	 */
	getPhpType: function () {
		return 'eshop_basket';
	},

	isAvailable: function () {
		var isProductBrowserWidget = Sb.EcwidWidgetsManager.isProductBrowserWidget();

		if (!isProductBrowserWidget) {
			this.disableReason = '';
			return false;
		}
		if (this.cache.length > 0) {
			this.disableReason = 'installed';
			return false;
		}
		return isProductBrowserWidget;
	}
});