/**
 * @class Sb.widgetType.Navigation
 * @extends Sb.widgetType.Base
 */
Ext.define('Sb.widgetType.Navigation', {
	extend: 'Sb.widgetType.Base',

	allowedColors: '',

	isDroppableTo: function (container) {
		return container.isInSiteWideArea();
	},

	cssTemplateSource: [
		'{className} li > a {',
			'<tpl if="level1FontSizeIsDependent == 0">font-size: {level1FontSize}px;</tpl>',
			'<tpl if="level1FontFamilyIsDependent == 0">font-family: {level1FontFamily};</tpl>',
		'}',
		'{className} > li {',
			'margin: {values.level1Margin};',
		'}',
		'{className} > li > a {',
			'font-weight: {[values.level1Bold ? "bold" : "normal"]};',
			'font-style: {[values.level1Italic ? "italic" : "normal"]};',
			'text-decoration: {[values.level1Underline ? "underline" : "none"]};',
			'padding: {values.level1Padding};',
			'border-width: {values.level1BorderWidth};',
			'border-style: solid;',
			'border-radius: {level1CornersRounding};',
			'box-shadow: {level1Shadow};',
		'}',
		'{className} ul li {',
			'margin: {values.level2Margin};',
		'}',
		'{className} ul li > a {',
			'font-weight: {[values.level2Bold ? "bold" : "normal"]};',
			'font-style: {[values.level2Italic ? "italic" : "normal"]};',
			'text-decoration: {[values.level2Underline ? "underline" : "none"]};',
			'padding: {values.level2Padding};',
			'border-width: {values.level2BorderWidth};',
			'border-style: solid;',
			'border-radius: {level2CornersRounding};',
			'box-shadow: {level2Shadow};',
		'}',
		'{className} li.selected, ',
		'{className} li.childselected, ',
		'{className} li.selected:hover, ',
		'{className} li.childselected:hover, ',
		'{className} li:hover {',
			'margin: {values.marginActive};',
		'}',
		'{className} li.selected > a, ',
		'{className} li.childselected > a, ',
		'{className} li.selected:hover > a, ',
		'{className} li.childselected:hover > a, ',
		'{className} li:hover > a {',
			'padding: {values.paddingActive};',
			'border-width: {values.borderWidthActive};',
			'border-style: solid;',
			'border-radius: {cornersRoundingActive};',
			'box-shadow: {shadowActive};',
		'}',
		'{className} ul li.selected, ',
		'{className} ul li.childselected, ',
		'{className} ul li.selected:hover, ',
		'{className} ul li.childselected:hover, ',
		'{className} ul li:hover{',
			'margin: {values.level2Margin};',
		'}',
		'{className} ul li.selected > a, ',
		'{className} ul li.childselected > a, ',
		'{className} ul li.selected:hover > a, ',
		'{className} ul li.childselected:hover > a, ',
		'{className} ul li:hover > a {',
			'padding: {values.level2Padding};',
		'}',
		'<tpl if="level1Background">',
			'{className} > li.normal > a {',
				'<tpl if="level1BackgroundGradient">',
					'background-image: linear-gradient({values.level1Background});',
					'background-size: 100% 100%;',
				'</tpl>',
				'<tpl if="!level1BackgroundGradient">',
					'background-image: url("{values.level1Background}");',
					'background-position: {values.level1BackgroundPosition};',
					'background-repeat: {values.level1BackgroundRepeat};',
					'background-size: {values.level1BackgroundSize};',
				'</tpl>',
				'}',
		'</tpl>',
		'{className} li.selected > a,',
		'{className} li.childselected > a,',
		'{className} li.normal:hover > a {',
			'<tpl if="level1BackgroundActive">',
				'<tpl if="level1BackgroundActiveGradient">',
					'background-image: linear-gradient({values.level1BackgroundActive});',
					'background-size: 100% 100%;',
				'</tpl>',
				'<tpl if="!level1BackgroundActiveGradient">',
					'background-image: url("{values.level1BackgroundActive}");',
					'background-position: {values.level1BackgroundPositionActive};',
					'background-repeat: {values.level1BackgroundRepeatActive};',
					'background-size: {values.level1BackgroundSizeActive};',
				'</tpl>',
			'</tpl>',
			'<tpl if="!level1BackgroundActive">',
				'background-image: none;',
			'</tpl>',
		'}',
		'<tpl if="level2Background">',
			'{className} ul > li.normal > a {',
				'<tpl if="level2BackgroundGradient">',
					'background-image: linear-gradient({values.level2Background});',
					'background-size: 100% 100%;',
				'</tpl>',
				'<tpl if="!level2BackgroundGradient">',
					'background-image: url("{values.level2Background}");',
					'background-position: {values.level2BackgroundPosition};',
					'background-repeat: {values.level2BackgroundRepeat};',
					'background-size: {values.level2BackgroundSize};',
				'</tpl>',
			'}',
		'</tpl>'
	],

	colorSchemeCssTemplateSource: [
		'<tpl>{className} > li.normal > a { color: {level1Color};}</tpl>',
		'<tpl>{className} > li.normal a { background-color: {level1BackgroundColor}; }</tpl>',
		'<tpl>{className} li.selected > a, {className} li.childselected > a { color: {level1ColorActive}; }</tpl>',
		'<tpl>{className} li.selected > a, {className} li.childselected > a { background-color: {level1BackgroundColorActive}; }</tpl>',
		'<tpl>{className} ul > li.normal > a { color: {level2Color}; }</tpl>',
		'<tpl>{className} ul > li.normal > a { background-color: {level2BackgroundColor}; }</tpl>',
		'<tpl>{className} li.normal:hover > a { color: {level1ColorActive}; }</tpl>',
		'<tpl>{className} li.normal:hover > a { background-color: {level1BackgroundColorActive}; }</tpl>',
		'<tpl>{className} > li > a { border-color: {level1BorderColor}; }</tpl>',
		'<tpl>{className} ul li > a { border-color: {level2BorderColor}; }</tpl>',
		'<tpl>{className} li.selected > a, {className} li.childselected > a, {className} li:hover > a { border-color: {borderColorActive}; }</tpl>'
	]
});